import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.CyclicBarrier;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;

public class Bug {

	public static final int OUTER_IT = 1000;
	public static final int MIDDLE_IT = 10;
	public static final int INNER_IT = 10;
	public static final int ARRAY_SIZE = 10000;
	public static final int NUM_THREADS = 4;

	public static void main(String[] args) {
		int[] A = new int[ARRAY_SIZE];
		bug(A);
		
		
	}


	private static void bug(final int[] A) {
		final ExecutorService e = Executors.newFixedThreadPool(NUM_THREADS);

		for (int i = 0; i < OUTER_IT; i++) {
			for (int z = 0; z < MIDDLE_IT; z++) {
				for (int j = 0; j < INNER_IT; j++) {
					bugFunction(A, e);
				}
			}
		}
		e.shutdown();
	}

	


	private static void bugFunction(final int[] A, ExecutorService e) {
		List<Future<Runnable>> tasks = new ArrayList<Future<Runnable>>();

		for (int i = 0; i < NUM_THREADS; i++) {
			Runnable r = new Runnable() {
				public void run() {
				}
			};

			Future<Runnable> t = e.submit(r, r);
			tasks.add(t);
		}

		for (Future<Runnable> future : tasks) {
			try {
				future.get();
			} catch (Exception e1) {
				e1.printStackTrace();
			}
		}
	}
}
